/*****************************************************************************/
/*
                                  upd.h
*/
/*****************************************************************************/

#ifndef UPD_H_LOADED
#define UPD_H_LOADED 1

#include "wasd.h"

/**************/
/* structures */
/**************/

struct UpdTaskStruct
{
   struct UpdTaskStruct  *UpdTaskPtr;

   boolean  /* SYSUAF authenticated user has been checked to have access */
            AuthVmsUserHasAccess,
            /* */
            BrowserFormHasOwnLineBreak,
            /* */
            BrowserSupportsFileUpload,
            /* */
            ConfigurationEdit,
            /* */
            FileExists,
            /* */
            ParseInUse,
            /* */
            RuleCheckAvailable,
            /* */
            UpdateTree;

   int  /* */
        Cols,
        /* */
        FileCount,
        /* */
        FileNameLength,
        /* */
        FilePathSize,
        /* */
        NavigateSize,
        /* */
        Rows,
        /* */
        TreeLevel;

   unsigned long  /* when creating files and directories */
                  ProtectionMask;

   char  /* */
         AsPath [256],
         /* */
         CxR [16],
         /* */
         ExpandedFileName [256],
         /* */
         FileName [256],
         /* tree processing, contains any name, type, version */
         FileNamePart [128],
         /* */
         FilePath [256],
         /* */
         HtmlEscapedTitle [256],
         /* used to store language-specific strings while in use */
         MsgString [256],
         /* MUST be 512 bytes (one block) for file copy purposes */
         ReadBuffer [512],
         /* */
         ResultantFileName [256];

   char  /* pointer to MIME content-type */
         *ContentTypePtr,
         /* current position during use of language-specific string */
         *MsgStringPtr;

   /* RMS structures */
   struct FAB  FileFab;
   struct RAB  FileRab;
   struct NAM  FileNam;
   struct XABDAT  FileXabDat;
   struct XABFHC  FileXabFhc;
   struct FAB  SearchFab;
   struct NAM  SearchNam;

   struct UpdTreeStruct  *TreeHeadPtr,
                         *TreeNodePtr;

   /* pointer to function, used for specifying the next task */
   void (*NextTaskFunction)(struct RequestStruct*);
};

struct UpdTreeStruct
{
   struct UpdTreeStruct  *PrevTreeNodePtr,
                         *NextTreeNodePtr;

   boolean  /* SYSUAF authenticated user has been checked to have access */
            AuthVmsUserHasAccess;

   int  /* */
        FileNameLength;

   char  /* */
         ExpandedFileName [256],
         /* */
         FileName [256],
         /* */
         ResultantFileName [256];

   /* RMS structures */
   struct FAB  SearchFab;
   struct NAM  SearchNam;
};

/***********************/
/* function prototypes */
/***********************/

UpdBegin (struct RequestStruct*, void*);
UpdConfirmCreate (struct RequestStruct*);
UpdConfirmDelete (struct RequestStruct*);
UpdConfirmRename (struct RequestStruct*, char*, char*, char*);
UpdCopyFileBegin (struct RequestStruct*);
UpdCopyFileEnd (struct RequestStruct*);
UpdCopyFileNextBlock (struct RequestStruct*);
UpdCopyFileNextBlockAST (struct RAB*); 
UpdEditFileBegin (struct RequestStruct*);
UpdEditFileEnd (struct RequestStruct*);
UpdEditFileNextRecord (struct RequestStruct*);
UpdEditFileNextRecordAST (struct RAB*); 
UpdEnd (struct RequestStruct*);
UpdNavigateBeginFiles (struct RequestStruct*);
UpdNavigateDirs (struct FAB*); 
UpdNavigateFiles (struct FAB*); 
UpdNavigateSearchDirs (struct RequestStruct*); 
UpdNavigateSearchFiles (struct RequestStruct*); 
UpdTreeListDirs (struct RequestStruct*);
UpdTreeDirs (struct FAB*); 
UpdTreeEnd (struct RequestStruct*);

#endif /* UPD_H_LOADED */

/*****************************************************************************/

