$!-----------------------------------------------------------------------------
$! UPDATE.COM
$!
$! WASD VMS Hypertext Services, Copyright (c) 1996-1999 Mark G.Daniel.
$! This package (all associated programs), comes with ABSOLUTELY NO WARRANTY.
$! This is free software, and you are welcome to redistribute it
$! under the conditions of the GNU GENERAL PUBLIC LICENSE, version 2.
$!
$! Update the WASD Hypertext Services Package.
$!
$! 31-OCT-1999  MGD  v6.1, new message database,
$!                         remove NETLIB support,
$!                         remove SSLeay support
$! 18-SEP-1999  MGD  OpenSSL 0.9.4
$! 05-MAY-1999  MGD  V6.0, new message database,
$!                         OpenSSL (Richard Levitte) distribution
$! 14-NOV-1998  MGD  v5.3, new server startup procedure
$! 03-SEP-1998  MGD  v5.2, no change
$! 27-JUN-1998  MGD  initial, v5.1 (and some would say long overdue!)
$!-----------------------------------------------------------------------------
$!
$ set noverify
$!
$ UPDATE_VERSION = "v6.1"
$!
$ if f$trnlnm("HT_ROOT","LNM$JOB") .eqs. ""
$ then
$!   (subprocess to do the actual work, define local logicals)
$    currentProcedure = f$environment("PROCEDURE")
$    procDevice = f$parse(currentProcedure,,,"DEVICE","NO_CONCEAL")
$    procDirectory = f$parse(currentProcedure,,,"DIRECTORY","NO_CONCEAL")
$!   (derive from the location of this procedure, assumes HT_ROOT tree!)
$    htRoot = procDevice +-
        (procDirectory --
         f$extract(f$locate("HT_ROOT",procDirectory),999,procDirectory)) +-
        "HT_ROOT.]"
$    define /job /nolog /translation=concealed HT_ROOT 'htRoot'
$    archName = f$edit(f$getsyi("ARCH_NAME"),"UPCASE")
$    if archName .eqs. "ALPHA" then archName = "AXP"
$    htExe = "HT_ROOT:[''archName']"
$    define /job /nolog HT_EXE 'htExe'
$!   (spawn a subprocess to do the actual install ensures job logical deletion)
$    spawn /wait @'currentProcedure' -
           "''P1'" "''P2'" "''P3'" "''P4'" "''P5'" "''P6'" "''P7'" "''P8'"
$    deassign /job HT_ROOT
$    deassign /job HT_EXE
$    exit
$ endif
$!
$ say = "write sys$command"
$ copy = "copy/log/prot=w:re"
$ purge = "purge/log"
$ currentDefault = f$environment("DEFAULT")
$!
$!-----------------------------------------------------------------------------
$!
$ type SYS$INPUT

WASD (HFRD) VMS Hypertext Services, Copyright (c) 1996-1998 Mark G.Daniel.
This package (all associated programs), comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it
under the conditions of the GNU GENERAL PUBLIC LICENSE, version 2.

$ say "--- UPDATE TO WASD VMS HYPERTEXT SERVICES ''UPDATE_VERSION' ---"
$ type SYS$INPUT

All sections making file-system modifications may be individually declined.
In this sense the update may be undertaken step-by-step or sections repeated.
The first section is LINKING, after which you will be able to quit.
In a mixed architecture cluster (including both Alpha and VAX systems)
the link section must be done on both!
$!
$!-----------------------------------------------------------------------------
$!
$ if f$trnlnm("HT_ROOT","LNM$SYSTEM") .eqs. ""
$ then
$    type SYS$INPUT

  *****************************************
  *  "HT_ROOT" logical name not detected. *
  *  This does not look like an update!   *
  *****************************************

$    exit
$ endif
$!
$ if f$search("HT_ROOT:[000000]*.*") .eqs. ""
$ then
$    type SYS$INPUT

  *********************************************************
  *  Appears to be a problem with the "HT_ROOT" logical!  *
  *********************************************************

$    exit
$ endif
$!
$!-----------------------------------------------------------------------------
$!
$ type SYS$INPUT

--- BUILD EXECUTABLES ---

| Package executables must be built.  This can be done two ways.
|   1. Compiling from source, then linking.       Respond: "COMPILE+LINK"
|   2. Linking separate package object modules.   Respond: "LINK"
|   or skip this step                             Respond: "SKIP"
| Build executables?
|
$ response = ""
$ if response .eqs. "" then response = "COMPILE+LINK"
$ read sys$command response /prompt="[COMPILE+LINK]: "
$ firstChar = f$edit(f$extract(0,1,response),"upcase")
$ if firstChar .eqs. "C"
$ then
$    set default HT_ROOT:[SRC]
$    @BUILD_ALL BUILD
$!   'f$verify(0)
$    set default 'currentDefault'
$ endif
$ if firstChar .eqs. "L"
$ then
$    set default HT_ROOT:[SRC]
$    @BUILD_ALL LINK
$!   'f$verify(0)
$    set default 'currentDefault'
$ endif
$!
$!-----------------------------------------------------------------------------
$!
$ if P1 .eqs. "SSL"
$ then
$    type SYS$INPUT

--- LINK SSL PACKAGE ---

|  Link for SSL version of HTTPd.
|  Link OpenSSL applications.
|  This will only work if the SSL package has been installed!
$    say "|  Link all object modules into executables?"
$    say "|"
$    response = ""
$    read sys$command response /prompt="[No]: "
$    if response
$    then
$       set default HT_ROOT:[SRC.HTTPD]
$       type SYS$INPUT

--- LINKING SSL VERSION OF HTTPD ---

$       @BUILD_HTTPD LINK SSL
$!      'f$verify(0)
$       if f$search("HT_ROOT:[SRC]OPENSSL-0_9_3.DIR") .nes. "" -
           then OpenSSLdir = "HT_ROOT:[SRC.OPENSSL-0_9_3]"
$       if f$search("HT_ROOT:[SRC]OPENSSL-0_9_4.DIR") .nes. "" -
           then OpenSSLdir = "HT_ROOT:[SRC.OPENSSL-0_9_4]"
$       type SYS$INPUT

--- LINKING OPENSSL APPLICATIONS ---

$       set default 'OpenSSLdir'
$       set default [.APPS]
$       @MAKEAPPS LINK
$       set default [-]
$    endif
$ endif
$!
$!-----------------------------------------------------------------------------
$!
$ type sys$input

--- SERVER QUICK-CHECK ---

|  This executes the package demonstration procedure,
|  allowing the basic package to be evaluated or checked.
|  You may run this at any time to again check the package for
|  basic functionality using @HT_ROOT:[000000]FREEWARE_DEMO.COM
|  Execute the demonstration procedure?
|
$ response = ""
$ read sys$command response /prompt="[No]: "
$ if response
$ then
$    if P1 .eqs. "SSL"
$       then @HT_ROOT:[000000]FREEWARE_DEMO.COM SSL
$       else @HT_ROOT:[000000]FREEWARE_DEMO.COM
$    endif
$ endif
$!
$!-----------------------------------------------------------------------------
$!
$ if P1 .eqs. "SSL"
$ then
$    type sys$input

--- SSL UPDATE COMPLETE ---

$    exit
$ endif
$!
$!-----------------------------------------------------------------------------
$!
$ type sys$input

--- CONTINUE UPDATE? ---

$ response = ""
$ read sys$command response /prompt="[No]: "
$ if .not. response
$ then
$    say ""
$    exit
$ endif
$!
$!-----------------------------------------------------------------------------
$!
$ if f$search ("HTTPD$MSG") .eqs. ""
$ then
$    type SYS$INPUT

  ********************************************
  *  "HTTPD$MSG" not found and not updated.  *
  *  This logical should be defined!         *
  ********************************************

$ else
$    type SYS$INPUT

--- UPDATE MESSAGE CONFIGURATION FILE ---

|  This version uses the v6.1 HTTPD$MSG configuration file.
|  If you are currently using less than v6.1 you will need to update.
|  Update your current version now?
|
$    read sys$command response /prompt="[No]: "
$    if response
$    then
$       say ""
$       copy HT_ROOT:[EXAMPLE]HTTPD$MSG.CONF HT_ROOT:[LOCAL]
$    endif
$ endif
$!
$!-----------------------------------------------------------------------------
$!
$ type SYS$INPUT

--- UPDATE TO v6.n STARTUP_SERVER.COM ---

|  Version 6.0 introduced revised startup procedures for support of proxy
|  serving.  If updating from v5.n consider moving to the startup environment.
|  These support single server systems yet can dramatically simplifying sites
|  with multiple server processes on the one system and/or across a cluster.
|
|  It does away with HT_ROOT:[HTTP$SERVER]HTTPD_BATCH.COM and HTTPD80.COM
|  using the single HT_ROOT:[LOCAL]STARTUP_SERVER.COM as well as updating
|  primary startup procedure HT_ROOT:[LOCAL]STARTUP.COM.
|  It does not delete the original two files, this can be done manually later.
|
|  Check the Technical Overview for how to best utilize these new procedures.
|
|  Update your current version of HT_ROOT:[LOCAL]STARTUP.COM now?
|  (replying "NO" results in the new startup being copied as STARTUP_V61.COM)
|
$ read sys$command response /prompt="[No]: "
$ say ""
$ if response
$    then copy HT_ROOT:[EXAMPLE]STARTUP.COM HT_ROOT:[LOCAL]
$    else copy HT_ROOT:[EXAMPLE]STARTUP.COM HT_ROOT:[LOCAL]STARTUP_V61.COM
$ endif
$ copy HT_ROOT:[EXAMPLE]STARTUP_SERVER.COM HT_ROOT:[LOCAL]
$!
$!-----------------------------------------------------------------------------
$!
$ if f$search("HT_ROOT:[000000]UPDATEAFTER.COM") .nes. ""
$ then
$    type sys$input

--- CLEAN UP AFTER PREVIOUS VERSION(S) ---

|  The procedure HT_ROOT:[000000]UPDATEAFTER.COM
|  deletes files from previous versions no longer in use
|  and otherwise cleans up after older versions of WASD.
|  (It is generally fairly conservative, but no guarantees.)
|  Alternatives: Execute the procedure now or later manually.
|  Execute the procedure now?
|
$    read sys$command response /prompt="[No]: "
$    if response
$    then
$       @HT_ROOT:[000000]UPDATEAFTER
$!      'f$verify(0)
$       set default 'currentDefault'
$    endif
$ endif
$!
$!-----------------------------------------------------------------------------
$!
$ type sys$input

--- PURGE OLD FILES ---

|  Performs a purge of the HT_ROOT:[000000] tree, removing replaced versions.
|  Alternatives: Purge now or later manually.
|
$ response = ""
$ read sys$command response /prompt="[No]: "
$ if response
$ then
$    say ""
$    purge HT_ROOT:[000000...]
$ endif
$!
$!-----------------------------------------------------------------------------
$!
$ type sys$input

--- UPDATE COMPLETE ---

$!
$!-----------------------------------------------------------------------------
